\chapter{Cylindrical Algebraic Decomposition for SMT solving}\label{ch:cad-SMT}
\chaptermark{CAD for SMT solving}

We have seen in the previous chapter that the cylindrical algebraic decomposition can be a powerful tool to analyze nonlinear arithmetic formulae.
Our aim is to leverage it to allow for reasonably efficient SMT solving for nonlinear arithmetic formulae.
Given what we have described so far, the naive approach is straightforward: upon a theory query, construct the corresponding CAD and figure out whether some cell is satisfying.

Within this chapter, we first work on how we understand CAD and go from a monolithic black-box to a modular incremental proof system.
Furthermore, we propose a whole range of optimizations to improve upon the naive solution in terms of practical performance and applicability.
This includes supporting \emph{incrementality} and \emph{backtracking}, generating \emph{reasons for unsatisfiability}, but also extending CAD to \emph{integer problems}.

The majority of the underlying ideas are already contained in~\cite{Kremer2020}, though we focus on algorithms and data structures for a practical implementation there while we aim for a more conceptual description here.
